<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 Alexander Kellner <alexander.kellner@einpraegsam.net>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(t3lib_extMgm::extPath('powermail').'lib/class.tx_powermail_functions_div.php'); // file for div functions
require_once(t3lib_extMgm::extPath('powermail').'lib/class.tx_powermail_markers.php'); // file for marker functions

class tx_powermailsendpost extends tslib_pibase {
	
	var $prefixId      = 'tx_powermailsendpost';		// Same as class name
	var $scriptRelPath = 'class.tx_powermailsendpost.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'powermail_sendpost';	// The extension key.
	var $pi_checkCHash = true;

	// Function PM_SubmitBeforeMarkerHook() to manipulate db entry
	function PM_SubmitLastOneHook($content, $conf, $sessiondata, $ok, $obj) {
		
		// config
		global $TSFE;
    	$this->cObj = $TSFE->cObj; // cObject
		$this->conf = $conf;
		$this->confArr = $obj->confArr;
		$this->obj = $obj;
		$this->sessiondata = $sessiondata;
		
		// let's start
		if ($ok == 1 && function_exists('curl_init') && $this->conf['powermail_sendpost.']['activate'] == 1) { // only if ok AND curl could be used AND plugin is activated

			$this->div = t3lib_div::makeInstance('tx_powermail_functions_div'); // New object: powermail div class for clear function
			$this->markers = t3lib_div::makeInstance('tx_powermail_markers'); // New object: powermail marker class for label function
		
			$this->post2target(); // start post2target function

		}
	}
	
	
	// Function post2target() sends values with CURL via POST to target
	function post2target() {
		$all = array(); // new array
		$all['data'] = $this->session2get() . ($this->cObj->cObjGetSingle($this->conf['powermail_sendpost.']['additionalData'], $this->conf['powermail_sendpost.']['additionalData.']) ? $this->cObj->cObjGetSingle($this->conf['powermail_sendpost.']['additionalData'], $this->conf['powermail_sendpost.']['additionalData.']) : ''); // key=value&key2=value
		$all['url'] = $this->conf['powermail_sendpost.']['targetURL']; // get target from ts
		
		$this->debug($all); // Debugmode if activated via TS
		
		if ($all['data'] && $all['url']) { // only if piVars set and only if target is set in typoscript
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $all['url']); // set the target url
			curl_setopt($ch, CURLOPT_POST, 1); // howmany parameter to post
			curl_setopt($ch, CURLOPT_POSTFIELDS, $all['data']); // the parameter 'username' with its value 'johndoe'
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // don't give anything back (important in TYPO3!)
			$result = curl_exec ($ch);
			curl_close ($ch);
		}
	}
	
	
	// Function session2get() changes values from powermailsession to a whole string (looks like GET params)
	function session2get() {
		if (count($this->sessiondata) > 0) { // if there are values in the session
			$string = ''; // clear string at the beginning
			
			foreach ($this->sessiondata as $key => $value) { // one loop for every entry in session
				if (is_numeric(str_replace('uid', '', $key))) { // take only keys like uid44 (no mailID, etc..)
					$this->conf['powermail_sendpost.']['useLabel'] == 1 ? $newkey = $this->div->clearName($this->markers->GetLabelfromBackend($key, $value), 1) : $newkey = $key; // use this key
					$this->cObj->cObjGetSingle($this->conf['powermail_sendpost.']['changeKey'], $this->conf['powermail_sendpost.']['changeKey.']) ? $newkey = $this->changeKey($key) : ''; // if changekey activated via typoscript, overwrite $newkey
					
					if (!is_array($value) && !empty($value)) { // first level
						$string .= '&'. $newkey .'='.urlencode($value); // &name=value
					} else { // second level
						for ($i=0; $i<count($value); $i++) {
							if (!empty($value[$i])) { // add only if there is a value
								$newkey2 = $newkey.'_'.$i;
								$this->conf['powermail_sendpost.']['changeKey'] ? $newkey2 = $this->changeKey($key.'_'.$i) : '';
								$string .= '&'. $newkey2 .'='.urlencode($value[$i]); // &name=value
							}
						}
					}
				}
			}
			$string = substr($string, 1); // delete first sign "&"
			
			if (!empty($string)) return $string;
		}
	}
	
	
	// Function changeKey() changes key if selected via TS
	function changeKey($k) {
		$arrayPart = t3lib_div::trimExplode(',', $this->cObj->cObjGetSingle($this->conf['powermail_sendpost.']['changeKey'], $this->conf['powermail_sendpost.']['changeKey.']), 1); // 3=>bla,4=>bla  to  3=>bla
		
		if (count($arrayPart) > 0) { // if there are values
			
			for ($i=0; $i < count($arrayPart); $i++) { // one loop for every part
				$array[$i] = t3lib_div::trimExplode('=>', $arrayPart[$i], 1); // 3=>bla  to 3 and bla
				if (str_replace('uid', '', $k) == $array[$i][0]) $content = $array[$i][1]; // if there is a hit, write it to $content
			}
		}
		
		if (!empty($content)) return $content; else return $k; // if there was a hit return this, if not return only the key (uid22)
		
	}
	
	
	// Function debug() generates a debug output
	function debug($all) {
		if ($this->conf['powermail_sendpost.']['debug'] ==1) { // if debugmode == 1
			$all['conf'] = $this->conf['powermail_sendpost.']; // add configuration to all array
			t3lib_div::debug($all, 'powermail_sendpost:'); // debug output
		}
	}

}
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/powermail_sendpost/class.tx_powermailsendpost.php']) {
	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/powermail_sendpost/class.tx_powermailsendpost.php']);
}
?>